"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Either = require("fp-ts/lib/Either");
const TaskEither = require("fp-ts/lib/TaskEither");
const function_1 = require("fp-ts/lib/function");
const pipeable_1 = require("fp-ts/lib/pipeable");
const Warn = require("./Warn");
exports.fromEither = function_1.flow(Either.map(Warn.of), TaskEither.fromEither);
exports.fromTaskEither = TaskEither.map(Warn.of);
exports.right = function_1.flow(Warn.of, TaskEither.right);
exports.payload = TaskEither.map(warn => warn.payload);
exports.warnings = TaskEither.map(warn => warn.warnings);
exports.map = function_1.flow(Warn.map, TaskEither.map);
function chain(f) {
    return (ma) => pipeable_1.pipe(TaskEither.right((p) => (w) => Warn.make(p.payload, p.warnings.concat(w))), TaskEither.ap(pipeable_1.pipe(ma, TaskEither.chain(w => f(w.payload)))), TaskEither.ap(exports.warnings(ma)));
}
exports.chain = chain;
function ap(fa) {
    return (fab) => pipeable_1.pipe(TaskEither.right((p) => (w1) => (w2) => Warn.make(p, w1.concat(w2))), TaskEither.ap(pipeable_1.pipe(exports.payload(fab), TaskEither.ap(exports.payload(fa)))), TaskEither.ap(exports.warnings(fa)), TaskEither.ap(exports.warnings(fab)));
}
exports.ap = ap;
